#!/usr/bin/python
# -*- coding: utf-8 -*-

# "PyNengou"
# SYMBIAN_UID = 0xe7c5e258
# masa
# (c) 2013 masa
# web = "http://masaland.cocolog-nifty.com/"

__script__  = "PyNengou"
__version__ = "1.00(0)"
__copy__    = "masa"
__web__     = "http://masaland.cocolog-nifty.com/"

import sys, os
#sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

# モジュール読込
import re, time
import appuifw, e32, globalui
from key_codes import EKey0 # mode switch
from key_codes import EKey2 # Begin
from key_codes import EKey3 # End
from key_codes import EKey4 # Goto
from key_codes import EKey6 # Middle
from key_codes import EKey7 # Search
from key_codes import EKey9 # neXt search
from key_codes import EKeyStar # 
from key_codes import EKeyHash #
from key_codes import EKeyLeftArrow
from key_codes import EKeyRightArrow
#from key_codes import EKeyUpArrow
#from key_codes import EKeyDownArrow


lock = e32.Ao_lock()

# マスタ情報
# 元号、スタート年マスター（西暦、平成、昭和、大正、明治、、、）
# 明治以降表示用
NENGO_MASTER0 = (("西暦",1,"seireki"),   ("平成",1989,"heisei"),("昭和",1926,"syouwa"),
                 ("大正",1912,"taisyou"),("明治",1868,"meizi"))
# 全部表示用
NENGO_MASTER1 = (("西暦",1,"seireki"),   ("平成",1989,"heisei"),("昭和",1926,"syouwa"),
                 ("大正",1912,"taisyou"),("明治",1868,"meizi"),
  ("慶応",1865,"keiou"),("元治",1864,"genzi"),("文久",1861,"bunkyuu"),("万延",1860,"man'en"),
  ("安政",1854,"ansei"),("嘉永",1848,"kaei"),("弘化",1844,"kouka"),("天保",1830,"tenpou"),
  ("文政",1818,"bunsei"),("文化",1804,"bunka"),("享和",1801,"kyouwa"),("寛政",1789,"kansei"),
  ("天明",1781,"tenmei"),("安永",1772,"an'ei"),("明和",1764,"meiwa"),("宝暦",1751,"houreki"),
  ("寛延",1748,"kan'en"),("延享",1744,"enkyou"),("寛保",1741,"kanpou"),("元文",1736,"genbun"),
  ("享保",1716,"kyouhou"),("正徳",1711,"syoutoku"),("宝永",1704,"houei"),
  ("元禄",1688,"genroku"),("貞享",1684,"zyoukyou"),("天和",1681,"tenna"),("延宝",1673,"enpou"),
  ("寛文",1661,"kanbun"),("万治",1658,"manzi"),("明暦",1655,"meireki"),
  ("承応",1652,"zyouou"),("慶安",1648,"keian"),("正保",1644,"syouhou"),("寛永",1624,"kan'ei"),
  ("元和",1615,"genna"),("慶/江",1603,"keityou edo"),("慶長",1596,"keityou"),
  ("安/桃",1573,"azuti momoyama"),("戦国",1467,"sengoku"),("室町",1392,"muromati"),
  ("室/南",1338,"muromati nanboku"),("鎌倉",1192,"kamakura"),("平安", 794,"heian"),
  ("奈良", 710,"nara"),("白鳳",645,"hakuhou"),("飛鳥",592,"asuka"))


# グローバル変数
# 左右キーでのジャンプ数
JUMP_RANGE = 7
# マスターテーブル関係　処理対象のテーブル、初期値は NENGO_MASTER0
NENGO_MASTER = NENGO_MASTER0
# リストボックス関連
LISTBOX = ""
LIST    = []
# 表示モード記憶
MODE = 0     # 0:明治以降　1:全部（飛鳥以降）
# 検索語
SEARCH_WORD = ""
# メニューリスト
MENU_LIST0 = []
MENU_LIST1 = []


def check_input(input_data, cur_pos):
    global MODE
    check = True
    lower, upper = 0, 0
    if cur_pos == 0: # 入力は西暦
        if MODE == 0: # 明治以降
            if input_data < 1868 or input_data > 2100 :
                check = False
                lower, upper = 1868, 2100
        else: # 全部表示のモード
            if input_data < 1 or input_data > 2100 :
                check = False
                lower, upper = 1, 2100
    else: # 入力は西暦以外
        if MODE == 0: # 明治以降
            if input_data < 1 or input_data > 200 :
                check = False
                lower, upper = 1, 200
        else: # 全部表示のモード
            if input_data < 1 or input_data > 400 :
                check = False
                lower, upper = 1, 400
    return check, lower, upper


def make_list(e_year): # e_year 入力した年号に対応する西暦年
    global LISTBOX, LIST, NENGO_MASTER
    # 各元号の年を作成
    year_list = []
    year_list.append("%5s" % e_year)
    for i in range(1,len(NENGO_MASTER)):
        wk = e_year - NENGO_MASTER[i][1] + 1
        # その時には存在しない元号
        if wk < 1:
            wk = ("--")
        year_list.append(wk)

    # 表示する年号リストを作成
    list = []
    for i in range(len(NENGO_MASTER) ):
        list.append(unicode(("%2d " + NENGO_MASTER[i][0] + "：%5s") 
                            % (i,year_list[i]), "UTF-8"))
    # return (unicode list)
    LIST = list
    return list


def selected():
    global MODE, LISTBOX, NENGO_MASTER
    cur_pos = LISTBOX.current()
    # 年号数字入力
    msg = unicode("入力 "+NENGO_MASTER[cur_pos][0] + "：", "UTF-8")
    if cur_pos == 0: # 西暦の欄
        e_year = int(time.strftime("%Y", time.localtime()))
        input_data = appuifw.query(msg,'number', e_year)
    else: # 元号の欄
        input_data = appuifw.query(msg,'number',1)
    if input_data == None: # canceled
        return
    # 入力チェック
    check, lower, upper = check_input(input_data, cur_pos) 
    if check == False: # input error
        globalui.global_note(unicode('数字が範囲外です\n%s -- %s' %
                (str(lower), str(upper)),'utf-8'),'info')
        return

    # 入力から西暦年作成
    e_year = NENGO_MASTER[cur_pos][1] + input_data - 1

    # 西暦年に対応する各元号の年を作成(return はunicodeのリスト)
    list = make_list(e_year)

    # 画面表示
    set_screen(list, cur_pos)


def set_screen(list, pos):
    global LISTBOX
    LISTBOX.set_list(list, pos)
    e32.ao_yield() # 画面反映


def go_to(pos_flg=None):
    #pos_flg b:begin  m:middle  e:end
    global LIST
    list_end = len(LIST) - 1
    if pos_flg == None: # input destination line number
        # 移動先行番数字入力
        msg = unicode("入力：移動先行番号 ", "UTF-8")
        pos = appuifw.query(msg,'number',0)
        if pos == None: # canceled
            return
        if pos > list_end:
            pos = list_end
    elif pos_flg == "b": pos = 0
    elif pos_flg == "m": pos = list_end/2
    elif pos_flg == "e": pos = list_end
    else :pos = 0
    set_screen(LIST, pos)


def arrowkey_jump(flg):
    # flg  b:back f:forward
    global LISTBOX, LIST, JUMP_RANGE
    cur_pos = LISTBOX.current()
    cur_pos_max = len(LIST) - 1
    if flg == 'f': # jump forward
        cur_pos = cur_pos + JUMP_RANGE
        if cur_pos > cur_pos_max :
            cur_pos = cur_pos_max
    else: # b jump backward
        cur_pos = cur_pos - JUMP_RANGE
        if cur_pos < 0 :
            cur_pos = 0
    set_screen(LIST, cur_pos)


def nengo_search(next=False):
    global MODE, LISTBOX, LIST, NENGO_MASTER, SEARCH_WORD
    cur_pos = LISTBOX.current()
    if next == True: # neXt search
        # 最初は空なので、例を入れて入力を促す
        if SEARCH_WORD == "":
            example = unicode("syouwa or 昭和", "UTF-8")
            msg = unicode("検索語が未入力\n入力： 検索語を入力", "UTF-8")
            input_data = appuifw.query(msg,'text', example) # return unicode
            if input_data == None: # canceled
                return
            SEARCH_WORD = input_data
        s_pos = cur_pos + 1 # start pos　次の行から検索
    else:
        # 検索語入力
        if SEARCH_WORD == "":
            example = unicode("syouwa or 昭和", "UTF-8")
        else:
            example = SEARCH_WORD
        msg = unicode("入力： 検索語を入力", "UTF-8")
        input_data = appuifw.query(msg,'text', example) # return unicode
        if input_data == None: # canceled
            return
        SEARCH_WORD = input_data
        s_pos = 0 # 最初の行から検索
    # 'と語尾のスペースを削除する　an'ei -> anei
    wk_word = (re.sub(u"'", u"", SEARCH_WORD)).strip()
    for i in range(s_pos, len(NENGO_MASTER)): 
        wk_text = unicode(NENGO_MASTER[i][0] + NENGO_MASTER[i][2], "UTF-8")
        # 'を削除する　an'ei -> anei
        wk_text = re.sub(u"'", u"", wk_text)
        if re.search(wk_word, wk_text, re.I) :
            set_screen(LIST, i)
            break
    else:
        msg = unicode('見つかりません:\n検索：', 'utf-8') + SEARCH_WORD
        globalui.global_note(msg,'info')


def mode_switch(flg):
    global MODE, NENGO_MASTER, NENGO_MASTER0, NENGO_MASTER1
    # 明治以降表示と全部表示を切り替える
    # flg 0:MODE0  1:MODE1  2:toggle
    if flg == 0:
        NENGO_MASTER = NENGO_MASTER0
        MODE = 0
    elif flg == 1:
        NENGO_MASTER = NENGO_MASTER1
        MODE = 1
    else:
        if MODE == 0:
            NENGO_MASTER = NENGO_MASTER1
            MODE = 1
        else:
            NENGO_MASTER = NENGO_MASTER0
            MODE = 0
    set_menu(MODE)

    # 今年の西暦に対応する各年号を作成(return はunicodeのリスト)
    list_copy = LIST[:] #旧リストのコピー作成　appuifw2 使用時のための対策
    e_year = int(time.strftime("%Y", time.localtime()))
    list = make_list(e_year) # return is unicode list
    # 表示
    set_screen(list_copy, 0) # appuifw2 使用時のための対策
    set_screen(list, 0)


def set_menu(flg=0):
    global MENU_LIST0, MENU_LIST1

    if flg == 0: # 明治以降
        appuifw.app.menu = MENU_LIST0
        LISTBOX.bind(EKey7, lambda: None)  # Search
        LISTBOX.bind(EKey9, lambda: None)  # neXt search
    else:
        appuifw.app.menu = MENU_LIST1
        LISTBOX.bind(EKey7, lambda: nengo_search())  # Search
        LISTBOX.bind(EKey9, lambda: nengo_search(next=True))  # neXt search
    appuifw.app.exit_key_handler = lambda:appExit() #do_dummy() #lock.signal()


def about():
    msg = "App: " + __script__ + "\n" + "Version: " + __version__ + "\n" + \
           __copy__ + "\n" + __web__
    appuifw.query(unicode(msg, "UTF-8"), "query")


def do_dummy():
  pass


# アプリ終了
def appExit():
    lock.signal()


def main():
    global LISTBOX, NENGO_MASTER
    global MENU_LIST0, MENU_LIST1

    # make menu list
    MENU_LIST0 = [(unicode("表示範囲(飛鳥～)(0)","utf-8"),lambda: mode_switch(1)),
                        (unicode("情報","utf-8"), about),
                        (unicode("終了","utf-8"), appExit) ]

    MENU_LIST1 = [(unicode("表示範囲(明治～)(0)","utf-8"), lambda: mode_switch(0)),
                        (unicode("カーソル移動","utf-8"), (
                          (unicode("先頭(b)", "UTF-8"), lambda: go_to("b")), #Begin
                          (unicode("中間(m)", "UTF-8"), lambda: go_to("m")), #Middle
                          (unicode("最後(e)", "UTF-8"), lambda: go_to("e")), #End
                          (unicode("行番(g)", "UTF-8"), lambda: go_to(None))  #End
                       )),
                        (unicode("検索","utf-8"), (
                          (unicode("検索(s)", "UTF-8"),   lambda: nengo_search(next=False)),
                          (unicode("次を検索(x)", "UTF-8"), lambda: nengo_search(next=True))
                       )),
                        (unicode("情報","utf-8"), about),
                        (unicode("終了","utf-8"), appExit) ]

    # 今年の西暦に対応する各年号を作成(return はunicodeのリスト)
    e_year = int(time.strftime("%Y", time.localtime()))
    list = make_list(e_year) # return is unicode list
    # 表示
    LISTBOX = appuifw.Listbox(list, selected)
    LISTBOX.bind(EKeyLeftArrow, lambda: arrowkey_jump('b'))
    LISTBOX.bind(EKeyRightArrow, lambda: arrowkey_jump('f'))

    LISTBOX.bind(EKey0, lambda: mode_switch(2)) # MODE switch
    LISTBOX.bind(EKey2, lambda: go_to("b"))       # Begin
    LISTBOX.bind(EKey3, lambda: go_to("e"))       # End
    LISTBOX.bind(EKey4, lambda: go_to(None))      # Goto line number
    LISTBOX.bind(EKey6, lambda: go_to("m"))       # Middle


    appuifw.app.body = LISTBOX
    appuifw.app.title = unicode(__script__ , "utf-8")
    e32.ao_yield() # 画面反映
    set_menu(flg=0)
    lock.wait()


if __name__ == '__main__':
    main()
#    sys.exit()

# EOF #

